#include <iostream>
#include <string>
#include <list>
#include <fstream>
#include <cstdlib>
#include <WordcatClasses.h>

using namespace std;

//Global Structures

list<Node> Nodes;
list<Node> Memory;
list<SuccConn> Links;
list<FamConn> Family;
int confidence = 0;

//Pre-declaration of fuctions
list<string> GetWord();
int LoadNetwork();
void DisStringList(list<string> word2b);
void DisAct(list<Node>::iterator start, list<Node>::iterator end);
void DisNodeList(list<Node> word2b);
void InputActivation(string input, int depth);
void ResetActivation(int depth);
string GetElement(list<string> word, int position);
void SpreadActivation(bool normal, bool fam);
list<Node>::iterator FindNode(list<Node>::iterator p, string node2find, int depth);
list<Node> GetPredictions1(string word);
list<Node> GetPredictions2(string word);
list<Node> ComparePredictions(list<Node> first, list<Node> second);
list<Node> PrunePredictions(list<Node> predictions, string element, int i);
list<string> Scan2(string word);
list<Node> Scan3(list<string> wordstring);
list<string> Recognize(list<string> word2b);
int AssessBG(list<Node> bestguess, list<string> word2b);
bool InComp(string find, list<string> here);
list<Node> String2Node(list<string> word);
list<Node> GetBG(list<string> recognized, list<string> word2b);
list<Node> SecondAttemptPreds(list<Node> bestguess, list<string> recognized);
list<string>::iterator MissingBinode(list<string>::iterator begin, list<string>::iterator end);
list<string> Remove1 (list<string> word);
list<string> Remove2 (list<string> word);
list<Node> Type1Pred(list<string> recognized, list<string> components);
list<Node> Type2Pred(list<string> recognized, list<string> components);
list<Node> Type3Pred(list<string> recognized, list<string> components);
list<Node> MergePred(list<Node> predictions, list<Node> predictions2);
list<string> EmployPrediction(list <string> recognized, list<Node> prediction);


int UseNetwork()
{	
	bool dummy = true;

	LoadNetwork();

	while(dummy)
	{	list<string> word2b = GetWord();
		list<string> recognized, components, newword;
		list<string>::iterator s;
		list<Node> bestguess, newpredictions;
		list<Node>::iterator p;
		string answer;

		if (GetElement(word2b, 1) == "|")
			break;

		word2b.push_front("*");
		word2b.push_back("*");

		recognized = Recognize(word2b);
		bestguess = GetBG(recognized, word2b);
		p = bestguess.begin();
		string firstbestguess = p->GetName();

		cout << "Certainty: " << confidence << endl;

		if(confidence < 75)
		{	
			int oldconfidence = confidence;
			newpredictions = SecondAttemptPreds(bestguess, recognized);
			if(newpredictions.size() >= 3)
				do
				{
					do
					{	newword = EmployPrediction(recognized, newpredictions);

//						cout << "New Recognized: ";
//						DisStringList(recognized);
						cout << "New Word: ";
						newword = Remove2(newword);
						DisStringList(newword);
	
						newword = Recognize(newword);
						bestguess = GetBG(newword, word2b);
						cout << "Certainty: " << confidence << endl;
	
						newpredictions.pop_front();
						newpredictions.pop_front();
						newpredictions.pop_front();
						
					} while((confidence <= oldconfidence) && !newpredictions.empty());
					recognized = newword;
					if(confidence < 75)
						newpredictions = SecondAttemptPreds(bestguess, recognized);
				} while((confidence < 75) && !newpredictions.empty());
	
			if(newpredictions.empty() && confidence < 75)
			{	newword = word2b;
				answer = "^" + firstbestguess;
			}
		}
		
		if(confidence >= 75)
		{	p = bestguess.begin();
			answer = p->GetName();	
		}

		cout << endl << "Answer: " << p->GetName() << endl;

	}
	return 1;
}


int UseNetworkFile()
{	
	bool dummy = true;
	string answer;

	LoadNetwork();

// open file to be recognized
	ifstream in("2bRecognized.txt");
	if(!in)
	{	cout << "Cannot open input file.\n";
		return 0;
	}
// open file for recognized text
	ofstream out("Recognized.txt");
	if(!out)
	{	cout << "Cannot open output file.\n";
		return 0;
	}
	
	do
	{	string word2bstring;
		list<string> word2b;
		list<string> recognized, components, newword;
		list<string>::iterator s;
		list<Node> bestguess, newpredictions;
		list<Node>::iterator p;

		in >> word2bstring;
		for(int i = 0; i != word2bstring.size(); ++i)
		{	string temp;
			temp = word2bstring[i];
			word2b.push_back(temp);
		}

		cout << endl << "Current Word: " << word2bstring << endl;

		word2b.push_front("*");
		word2b.push_back("*");

		recognized = Recognize(word2b);
		bestguess = GetBG(recognized, word2b);
		p = bestguess.begin();
		string firstbestguess = p->GetName();
	
		cout << "Certainty: " << confidence << endl;
	
		if(confidence < 75)
		{	
			int oldconfidence = confidence;
				
			newpredictions = SecondAttemptPreds(bestguess, recognized);
	
			if(newpredictions.size() >= 3)
				do
				{
					do
					{	newword = EmployPrediction(recognized, newpredictions);
	
//						cout << "New Recognized: ";
//						DisStringList(recognized);
						cout << "New Word: ";
						newword = Remove2(newword);
						DisStringList(newword);
		
						newword = Recognize(newword);
						bestguess = GetBG(newword, word2b);
						cout << "Certainty: " << confidence << endl;
	
						newpredictions.pop_front();
						newpredictions.pop_front();
						newpredictions.pop_front();
							
					} while((confidence <= oldconfidence) && !newpredictions.empty());
					recognized = newword;
					if(confidence < 75)
						newpredictions = SecondAttemptPreds(bestguess, recognized);
				} while((confidence < 75) && !newpredictions.empty());
		
			if(newpredictions.empty() && confidence < 75)
			{	newword = word2b;
				answer = "^" + firstbestguess;
			}
		}

		if(confidence >= 75)
		{	p = bestguess.begin();
			answer = p->GetName();
		}

		cout << endl << word2bstring << " : " << answer << endl << endl;
		out << answer << " ";
	} while (!in.eof());

	in.close();
	out.close();

	cout << "Done!\n";

	return 1;
}


list<Node> SecondAttemptPreds(list<Node> bestguess, list<string> recognized)
{	list<Node> newpredictions, newpredictions2, newpredictions3;
	list<Node>::iterator p;
	list<string> components;
	list<string>::iterator s;

// Get the binode components of the top 2 bestguesses
	p = bestguess.begin();
	int activation, newactivation;

	activation = p->GetActivation()*100;
	components.merge(Scan2(p->GetName()));
	++p;
	if(p != bestguess.end())
	do
	{	cout << ".";
		components.merge(Scan2(p->GetName()));
		newactivation = p->GetActivation()*100;
		++p;
	} while(activation == newactivation && p != bestguess.end());

//	cout << "Recognized: ";
//	DisStringList(recognized);

	cout << endl;

	newpredictions = Type1Pred(recognized, components);
	newpredictions2 = Type2Pred(recognized, components);
	newpredictions3 = Type3Pred(recognized, components);

	newpredictions = MergePred(newpredictions, newpredictions2);
	newpredictions = MergePred(newpredictions, newpredictions3);

	cout << endl << "Predictions: ";
	DisNodeList(newpredictions);
	cout << endl;

	return newpredictions;
}


list<string> EmployPrediction(list <string> recognized, list<Node> prediction)
{	list<string> newword;
	list<string>::iterator s;
	list<Node>::iterator p;
	string pred, oldnode, newnode;
	bool done = false;

	p = prediction.begin();
	pred = p->GetName();
	++p;
	oldnode = p->GetName();
	++p;
	newnode = p->GetName();

	s = recognized.begin();
	do
	{	if(*s == pred)
		{	++s;
			if(*s == oldnode)
				done = true;
		}
		++s;
	} while(!done);
	--s;  // this now points to "oldnode" in recognized

	if(oldnode.size()==1)
	{	
		list<string>::iterator test = s;
		++test;
		string nextnode = *test;
		if(nextnode.size() == 1)
		{	list<string> temp;
			temp.push_back(newnode);
			recognized.splice(s, temp);
			++s;
			newnode = newnode[1];
			*s = newnode;
		}
		else if(nextnode.size() > 1)
		{	++s; ++s;
			newnode = newnode[1];
			*s = newnode;
		}
	}
	else if(oldnode.size()>1)
	{
		if(oldnode[1] == newnode[1])
		{
			++s;
			newnode = newnode[0];
			*s = newnode;
		}
		else if(oldnode[0] == newnode[0])
		{
			++s; ++s;
			string temp = *s;
			if(temp.size() == 2)
				++s;
			newnode = newnode[1];
			*s = newnode;
		}
	}

	++s;
	if(s == recognized.end())
	{	--s;
		recognized.push_back("*");
	}
	
	return recognized;
}

list<Node> MergePred(list<Node> predictions, list<Node> predictions2)
{
	list<Node>::iterator p, p2;
	bool done = false;

	if(predictions.empty())
		return predictions2;
	else if(predictions2.empty())
		return predictions;
	else
	{
		p = predictions.begin();

		do
		{
			p2 = predictions2.begin();
			if (p == predictions.end())
			{
				predictions.push_back(*p2);
				++p2;
				predictions.push_back(*p2);
				++p2;
				predictions.push_back(*p2);
				predictions2.pop_front();
				predictions2.pop_front();
				predictions2.pop_front();
				p = predictions.begin();
			}
			else
			{
				string node1 = p->GetName();
				string node2 = p2->GetName();

				if(node1 == node2)
				{
					++p; ++p; ++p2; ++p2;
					node1 = p->GetName();
					node2 = p2->GetName();
					if(node1 == node2)
					{
						p->SetActivation(p->GetActivation() + p2->GetActivation());
						predictions2.pop_front();
						predictions2.pop_front();
						predictions2.pop_front();
						p = predictions.begin();
					}
					else
					{	++p; --p2; --p2;}
				}
				else
				{	++p; ++p; ++p;}
			}
		} while(!predictions2.empty());


		//sort predictions according to activation
		if(!predictions.empty())
		{	
			list<Node> temp;
			float current;
			float high = 0;
			list<Node>::iterator target, endtarget;

			do
			{	p = predictions.begin();
				high = 0;
				do
				{	++p; ++p;
					current = p->GetActivation();
					if(current > high)
					{	target = p;
						high = current;
					}
					++p;
				} while(p != predictions.end());
				--target; --target;
				temp.push_back(*target);
				++target;
				temp.push_back(*target);
				++target; endtarget = target;
				temp.push_back(*target);
				--target; --target;

				predictions.erase(target, ++endtarget);
			} while (!predictions.empty());
			predictions = temp;
		}
		return predictions;
	}
}

// Type3 - Find missing binode, assume previous is WRONG and backup and check for a newone.
list<Node> Type3Pred(list<string> recognized, list<string> components)
{	
	list<string>::iterator s, s2, test, test2;
	list<Node> predictions, predictions2, newpredictions;
	list<Node>::iterator p, p2, p3;

	s = MissingBinode(recognized.begin(), recognized.end());
	test = recognized.begin();
	++test;
	test2 = recognized.end();
	--test2; --test2;

	if((s == recognized.end()) || (s == recognized.begin()) || (s == test))
		return newpredictions;
	else if (s == test2)
	{
		string following = *s;
		--s;
		s2 = s;
		--s;
		
		p2 = FindNode(Nodes.begin(), *s, 2);
		predictions = GetPredictions2(*s);

		for(p = predictions.begin(); p != predictions.end(); ++p)
		{	string name = p->GetName();
			name = name[0];

			if(InComp(p->GetName(), components) && (name == following) && (p->GetName() != *s2))
			{	newpredictions.push_back(*p2);
				p3 = FindNode(Nodes.begin(), *s2, 2);
				newpredictions.push_back(*p3);
				newpredictions.push_back(*p);
			}
		}
		return newpredictions;
	}
	else
	{
		++s;
		string following = *s;
		--s;
		string target = *s;
		--s;
		s2 = s;
		--s;

		p2 = FindNode(Nodes.begin(), *s, 2);
		predictions = GetPredictions2(*s);
//		predictions2 = GetPredictions(target);
//		predictions = ComparePredictions(predictions, predictions2);

//		DisNodeList(predictions);

		for(p = predictions.begin(); p != predictions.end(); ++p)
		{	string name = p->GetName();
			if(name.size() == 2)
				name = name[1];
			
			if(InComp(p->GetName(), components) && (name == following) && (p->GetName() != *s2))
			{
				newpredictions.push_back(*p2);
				p3 = FindNode(Nodes.begin(), *s2, 2);
				newpredictions.push_back(*p3);
				newpredictions.push_back(*p);
			}
		}
		return newpredictions;
	}
}

// Type2 - Find first missing binode. Assume previous binode is correct and find forward
list<Node> Type2Pred(list<string> recognized, list<string> components)
{
	list<string>::iterator s, s2;
	list<Node> predictions, predictions2, newpredictions;
	list<Node>::iterator p, p2, p3;

	s = MissingBinode(recognized.begin(), recognized.end());

	if(s == recognized.end())
		return newpredictions;
	else
	{	s2 = s;
		++s2;

		p2 = FindNode(Nodes.begin(), *s, 2);
		predictions = GetPredictions2(*s);
		predictions2 = GetPredictions2(*s2);
		predictions = ComparePredictions(predictions, predictions2);

		for(p = predictions.begin(); p != predictions.end(); ++p)
		{	string name = p->GetName();
			name = name[0];
			if(InComp(p->GetName(), components) && (name == *s2))
			{	newpredictions.push_back(*p2);
				p3 = FindNode(Nodes.begin(), *s2, 2);
				newpredictions.push_back(*p3);
				newpredictions.push_back(*p);
			}
		}
		return newpredictions;
	}
}

// Type1 Predictions: Find a node that is recognized but not in components and try another...
list<Node> Type1Pred(list<string> recognized, list<string> components)
{
	list<string>::iterator s, s2;
	list<Node> newpredictions;
	list<Node>::iterator p, p2, p3;

	s2 = recognized.begin();
	++s2;

	for(s = s2; s != recognized.end(); ++s)
	{	
		string current = *s;
		if((!(InComp(current, components))) && (current.size() > 1))  // if a recognized binode is not in top 2 then get new predictions for previous node
		{
			s2 = s;
			--s2; // back up one Node

			list<Node> predictions = GetPredictions2(*s2); // get predictions

			for(p = predictions.begin(); p != predictions.end(); ++p)  // prune predictions
			{	string namenew = p->GetName();
				if (InComp(namenew, components) && (namenew != current) &&((namenew[0] == current [0]) || (namenew[1] == current[1])))
				{	p2 = FindNode(Nodes.begin(), *s2, 2);
					p3 = FindNode(Nodes.begin(), current, 2);
					newpredictions.push_back(*p2);
					newpredictions.push_back(*p3);
					newpredictions.push_back(*p);
				}
			}
		}
	}
	return newpredictions;
}


list<string>::iterator MissingBinode(list<string>::iterator s, list<string>::iterator end)
{
	list<string>::iterator s2;
	bool done = false;

	s2 = s;
	++s2;

	do
	{	string first = *s;
		string second = *s2;
		if((first.size() == second.size()) && (s2 != end))
			done = true;

		++s;
		++s2;
	} while((s2 != end) && (!done));

	if(done)
	{	--s; return s;}
	else
		return end;
}


list<Node> GetBG(list<string> recognized, list<string> word2b)
{	list<Node> bestguess;
	list<Node>::iterator p;

	bestguess = Scan3(recognized);

	for (p = bestguess.begin(); p != bestguess.end(); ++p)
	{	int percent = (p->GetActivation()*100);
		cout << p->GetName() << " " << percent << "%  ";
	}
	cout << endl;

	confidence = (AssessBG(bestguess, word2b));

	return bestguess;
}


list<string> Recognize(list<string> word2b)
{
	list<string> recognized;
	list<string>::iterator s;
	list<Node>::iterator p;
	const int before = 0;
	const int after = 1;

	bool validbegin = false;
	bool done = false;
	string first = "*";
	list<Node> afterstar = GetPredictions1(GetElement(word2b, 1));
	p = afterstar.begin();
	do
	{	if (p->GetName() == GetElement(word2b, 2))
		{	validbegin = true; done = true; first += GetElement(word2b, 2);}
		++p;
	}	while (!done && (p != afterstar.end()));
	if(validbegin)
		recognized.push_back(first);

	for (int i = 1; i != word2b.size()-1; ++i)
	{	list<Node> predictions = GetPredictions1(GetElement(word2b, i));
		list<Node> predictions2 = GetPredictions1(GetElement(word2b, (i+1)));
		list<Node> compared = ComparePredictions(predictions, predictions2);
		compared = PrunePredictions(compared, GetElement(word2b, (i+1)), before);

		compared = PrunePredictions(compared, GetElement(word2b, (i+2)), after);
		cout << ".";
//		cout << "Compared " << GetElement(word2b, i) << " " << GetElement(word2b, i+1) << " " << GetElement(word2b, i+2) << ": ";
//		DisNodeList(compared);

		if (compared.size() == 1)
		{	recognized.push_back(GetElement(word2b, i));
			p = compared.begin();
			recognized.push_back(p->GetName());
		}
		else if (compared.size() != 1)
			recognized.push_back(GetElement(word2b, i));

	}

	recognized.push_back(GetElement(word2b, word2b.size()-1));

	string last = GetElement(recognized, recognized.size()-1);
	if(last[1] != '*')
	{	bool validend = false;
		done = false;
		last = GetElement(word2b, word2b.size()-1);
		afterstar = GetPredictions1(GetElement(word2b, word2b.size()-1));
		p = afterstar.begin();
		do
		{	if (p->GetName() == "*")
			{	validend = true; done = true; last += "*";}
			++p;
		}	while (!done && (p != afterstar.end()));
		if(validend)
			recognized.push_back(last);
	}

	recognized.push_back(GetElement(word2b, word2b.size()));

	if(GetElement(word2b, word2b.size()) != "*")
		recognized.push_back("*");

	cout << endl << "Recognized: ";
	DisStringList(recognized);
	cout << endl;

	return recognized;
}
	

list<Node> PrunePredictions(list<Node> predictions, string element, int i)
{
	list<Node>::iterator p;
	list<Node> pruned;

	for (p = predictions.begin(); p != predictions.end(); ++p)
	{	string name = p->GetName();
		name = name[i];
		if (name == element)
			pruned.push_back(*p);
	}

//	cout << element << ": ";
//	DisNodeList(pruned);

	return pruned;
}


list<Node> ComparePredictions(list<Node> first, list<Node> second)
{
	list<Node>::iterator p, p2, p3;
	list<Node> match, nomatch;

	for (p = first.begin(); p != first.end(); ++p)
	{
		if (p->GetDepth() == 2)
		{	string name = p->GetName();
			name = name[1];

			bool found = false;
			for (p2 = second.begin(); p2 != second.end(); ++p2)
				if (p2->GetName() == name)
					found = true;

			if (found)
				match.push_back(*p);
		}
	}

	return match;
}


list<Node> GetPredictions1(string word)
{
	list<Node> predictions;
	list<Node>::iterator p, p2;
	list<SuccConn>::iterator q;

	bool done = false;
	q = Links.begin();
	do
	{
		if (q->GetPred() < word)
			++q;
		else if (q->GetPred() == word)
		{	p = FindNode(Nodes.begin(), q->GetSucc(), 2);
			predictions.push_back(*p);
			++q;
		}
		else if (q->GetPred() > word)
			done = true;
	} while (!done && q != Links.end());
	
	return predictions;
}


list<Node> GetPredictions2(string word)
{
	list<Node> predictions;
	list<Node>::iterator p, p2;
	list<SuccConn>::iterator q;

	ResetActivation(3);
	Memory = Nodes;
	InputActivation(word, 2);
	SpreadActivation(true, false);

	for (p = Nodes.begin(); p != Nodes.end(); ++p)
	{	
		if ((p->GetActivation() > 0) && (p->GetDepth() < 3))
		{	
			bool done = false;
			p2 = predictions.begin();

			do
			{	if (p2 == predictions.end())  // Checks if you've reached the end and not done - if so create the node in last place
				{	predictions.push_back(*p);
					done = true;
				}
				else if ((p2 != predictions.end()) && (p2->GetActivation() <= p->GetActivation()))
				{	list<Node> temp;
					temp.push_back(*p);
					predictions.splice(p2, temp);
					done = true;
				}
				++p2;	
			}	while (!done);
		}
	}
	
	return predictions;
}


int AssessBG(list<Node> bestguess, list<string> word2b)
{	list<Node>::iterator p;

	p = bestguess.begin();
	float top = p->GetActivation();
	string topname = p->GetName();
	++p;
	float second = p->GetActivation();
	string secondname = p->GetName();

	int firstfit = (top*100) - (abs(topname.size()-(word2b.size()-2))*10);
	int secondfit = (second*100) - (abs(secondname.size()-(word2b.size()-2))*10);
	int confidence = firstfit + (firstfit - secondfit);

	return confidence;
}


list<Node> Scan3(list<string> wordstring)
{
	list<Node> predictions;
	list<Node>::iterator p, p2;
	list<Node> word;

	word = String2Node(wordstring);
//	for (list<string>::iterator s = wordstring.begin(); s != wordstring.end(); ++s)
//	{	p = FindNode(Nodes.begin(), *s, 2);
//		word.push_back(*p);
//	}

	ResetActivation(3);
	Memory=Nodes;
	for (p = word.begin(); p != word.end(); ++p)
		if (p->GetDepth() == 2)
			InputActivation(p->GetName(), 2);
	SpreadActivation(false, true);

	for (p = Nodes.begin(); p != Nodes.end(); ++p)
	{	
		if ((p->GetActivation() > 0) && (p->GetDepth() == 3))
		{	
			bool done = false;
			p2 = predictions.begin();
				do
			{	if (p2 == predictions.end())  // Checks if you've reached the end and not done - if so create the node in last place
				{	predictions.push_back(*p);
					done = true;
				}
				else if ((p2 != predictions.end()) && (p2->GetActivation() <= p->GetActivation()))
				{	list<Node> temp;
					temp.push_back(*p);
					predictions.splice(p2, temp);
					done = true;
				}
				++p2;	
			}	while (!done);
		}
	}

	return predictions;
}


list<string> Scan2(string word)
{
	list<string> components;
	list<Node>::iterator p;


	ResetActivation(3);
	Memory=Nodes;
	InputActivation(word, 3);
	SpreadActivation(false, true);

	for (p = Nodes.begin(); p != Nodes.end(); ++p)
		if ((p->GetActivation() > 0) && (p->GetDepth() == 2))
			components.push_back(p->GetName());

	return components;
}


bool InComp(string find, list<string> here)
{	
	list<string>::iterator s;
	bool yes = false;

	for(s = here.begin(); s != here.end(); ++s)
	{	if(*s == find)
			yes = true;
	}

	return yes;
}


list<Node> String2Node(list<string> word)
{
	list<string>::iterator s;
	list<Node> nodelist;
	list<Node>::iterator p;

	for (s = word.begin(); s != word.end(); ++s)
	{	p = FindNode(Nodes.begin(), *s, 2);
		nodelist.push_back(*p);
	}

	return nodelist;
};

void SpreadActivation(bool normal, bool fam)
{
	string predname, succname;
	float weight, activation;
	list<Node>::iterator succ, mempred;
	list<SuccConn>::iterator q;
	list<FamConn>::iterator r;
	int first, second;

	if(normal)
	for (q = Links.begin(); q != Links.end(); ++q)
	{	
		// Load Link Info
		predname = q->GetPred();
		succname = q->GetSucc();
		weight = q->GetWeight();

		// Calculate and update new activation
		mempred = FindNode(Memory.begin(), predname, 2);
		succ = FindNode(Nodes.begin(), succname, 2);

		activation = mempred->GetActivation() * weight + succ->GetActivation();
		succ->SetActivation(activation);
	}

	if(fam)
	for (r = Family.begin(); r != Family.end(); ++r)
	{
		// Load Link Info
		predname = r->GetPred();
		succname = r->GetSucc();
		weight = r->GetWeight();
		
		if(predname[0] == '3')
		{	predname.erase(0, 1);
			first = 3; second = 2;
		}
		else if (succname[0] == '3')
		{	succname.erase(0, 1);
			first = 2; second = 3;
		}

		// Calculate and update new activation
//		cout << predname << "..";
		mempred = FindNode(Memory.begin(), predname, first);
//		cout << "Found mempred\n";

//		cout << succname << ".." << second << "..";
		succ = FindNode(Nodes.begin(), succname, second);
//		cout << "Found succ\n";

		activation = mempred->GetActivation() * weight + succ->GetActivation();
		succ->SetActivation(activation);
	}

	Memory = Nodes;

//	cout << "spread.\n";
}

string GetElement(list<string> word, int position)
{
	string element;
	list<string>::iterator s;
	int i;

	s = word.begin();

	for (i = 0; i != position; ++i)
	{	element = *s;
		++s;
	}

	return element;
}


void DisAct(list<Node>::iterator start, list<Node>::iterator end)
{
	list<Node>::iterator p;

	cout << endl << "1: ";
	for (p = start; p != end; ++p)
		if (p->GetDepth() == 1)
		{	int activation = (p->GetActivation()*1000);
			cout << activation << " ";
		}

	cout << endl << "2: ";
	for (p = start; p != end; ++p)
		if (p->GetDepth() == 2)
		{	int activation = (p->GetActivation()*1000);
			cout << activation << " ";
		}

	cout << endl << "3: ";
	for (p = start; p != end; ++p)
		if (p->GetDepth() == 3)
		{	int activation = (p->GetActivation()*1000);
			cout << activation << " ";
		}

	cout << endl;
}


void ResetActivation(int depth)
{
	list<Node>::iterator p;

	Memory = Nodes;

	for (p = Nodes.begin(); p != Nodes.end(); ++p)
		if (p->GetActivation() <= depth)
			p->SetActivation(0.0);
}


list<Node>::iterator FindNode(list<Node>::iterator p, string node2find, int depth)
{
	bool done = false;
	if(depth == 3)
		do
		{
			if (p->GetName() == node2find)
			{	if (p->GetDepth() == depth)
					done = true;
				else
					++p;
			}
			else if (p->GetName() != node2find  ||  p->GetDepth() != depth)
				++p;
		} while (!done);
	else if(depth < 3)
		do
		{
			if (p->GetName() == node2find)
			{	if (p->GetDepth() <= depth)
					done = true;
				else
					++p;
			}
			else if (p->GetName() != node2find)
				++p;
		} while (!done);

	return p;
}
			

void InputActivation(string input, int depth)
{
	list<Node>::iterator p;

	p = FindNode(Memory.begin(), input, depth);
	p->SetActivation(1.0);
}



void DisStringList(list<string> word2b)
{
	list<string>::iterator l;

//	cout << endl;

	for (l = word2b.begin(); l != word2b.end(); ++l)
		cout << *l << " ";
	
	cout << endl;
}


void DisNodeList(list<Node> word2b)
{
	list<Node>::iterator p;

	for (p = word2b.begin(); p != word2b.end(); ++p)
		cout << p->GetName() << " ";
	
	cout << endl;
}


list<string> Remove1 (list<string> word)
{
	list<string>::iterator s;
	list<string> newword;

	for(s = word.begin(); s != word.end(); ++s)
	{	string node = *s;
		if(node.size() == 2)
			newword.push_back(node);
	}

	return newword;
}


list<string> Remove2 (list<string> word)
{
	list<string>::iterator s;
	list<string> newword;

	for(s = word.begin(); s != word.end(); ++s)
	{	string node = *s;
		if(node.size() == 1)
			newword.push_back(node);
	}

	return newword;
}


list<string> GetWord()
{	string word;
	list<string> word2b;

	cout << endl << "Please enter a word (| to exit):\n";

	cin >> word;

	for (int i = 0; i != word.size(); ++i)
	{	string temp = "";
		temp += word[i];
		word2b.push_back(temp);
	}

	return word2b;
}


int LoadNetwork()
{


	string prev, current;
	char filename[14] = "Network.txt";
	int depth;
	float weight, famweight;

// open network to be used
//	cout << "Please enter Network filename: ";
//	cin >> filename;

	ifstream in(filename);
	if(!in)
	{	cout << "Cannot open input file.\n";
		return 0;
	}

	in >> current;

	cout << "Loading " << current;

	in >> current;

	do
	{	in >> current;
		in >> depth;

		if (current != "Links:")
			Nodes.push_back(Node(current,depth));

//		cout << current;
	}	while (current != "Links:");
			
	cout << endl << "Loading " << current;

	do
	{	in >> prev;
		in >> weight;
		in >> current;

		if (prev != "Family:")
			Links.push_back(SuccConn(prev, current, weight));

	}	while (prev != "Family:");

	cout << endl << "Loading " << prev;

	do
	{	in >> prev;
		in >> current;
		in >> famweight;

		if (!in.eof())
			Family.push_back(FamConn(prev, current, famweight));

	}	while (!in.eof());

	in.close();

	cout << endl << "Done Loading." << endl;
	cout << endl << "Nodes: " << Nodes.size() << endl;
	cout << "Links: " << Links.size() << endl;
	cout << "Family: " << Family.size() << endl;

	int i = 0;
	for (list<Node>::iterator p = Nodes.begin(); p != Nodes.end(); ++p)
	{	if (p->GetDepth() == 3)
			++i;
	}
	cout << "Words: " << i << endl;

	return 0;
}